package com.netmera.netmera_flutter_sdk;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

import com.netmera.NetmeraPushBroadcastReceiver;
import com.netmera.NetmeraPushObject;

import io.flutter.view.FlutterMain;

/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */
public class FNetmeraPushBroadcastReceiver extends NetmeraPushBroadcastReceiver {

    private static final String TAG = "Netmera Android";

    public static final String ON_PUSH_REGISTER = "onPushRegister";
    public static final String ON_PUSH_RECEIVE = "onPushReceive";
    public static final String ON_PUSH_OPEN = "onPushOpen";
    public static final String ON_PUSH_DISMISS = "onPushDismiss";
    public static final String ON_PUSH_BUTTON_CLICKED = "onPushButtonClicked";

    @Override
    protected void onPushRegister(Context context, String gcmSenderId, String pushToken) {
        Bundle bundle = new Bundle();
        bundle.putString("gcmSenderId", gcmSenderId);
        bundle.putString("pushToken", pushToken);
        sendMessage(context, ON_PUSH_REGISTER, bundle);
    }

    @Override
    protected void onPushReceive(Context context, Bundle bundle, NetmeraPushObject netmeraPushObject) {
        sendMessage(context, ON_PUSH_RECEIVE, bundle);
    }

    @Override
    protected void onPushOpen(Context context, Bundle bundle, NetmeraPushObject netmeraPushObject) {
        sendMessage(context, ON_PUSH_OPEN, bundle);
    }

    @Override
    protected void onPushDismiss(Context context, Bundle bundle, NetmeraPushObject netmeraPushObject) {
        sendMessage(context, ON_PUSH_DISMISS, bundle);
    }

    @Override
    protected void onPushButtonClicked(Context context, Bundle bundle, NetmeraPushObject netmeraPushObject) {
        sendMessage(context, ON_PUSH_BUTTON_CLICKED, bundle);
    }

    private void sendMessage(Context context, String action, Bundle bundle) {
        FlutterMain.ensureInitializationComplete(context, null);
        Intent intent = new Intent(action);
        intent.putExtras(bundle);
        FNetmeraService.enqueueWork(context, intent);
    }
}