package com.netmera.netmera_flutter_sdk;

import com.netmera.NetmeraPushObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */
class FNetmeraPushObject {

    static List<HashMap<String, Object>> mapPushObjects(List<NetmeraPushObject> pushObjects) {
        List<HashMap<String, Object>> pushObjectList = new ArrayList<>();
        for (NetmeraPushObject netmeraPushObject : pushObjects) {
            pushObjectList.add(getPushObjectMap(netmeraPushObject));
        }
        return pushObjectList;
    }

    private static HashMap<String, Object> getPushObjectMap(NetmeraPushObject pushObject) {
        HashMap<String, Object> map = new HashMap<>();
        map.put("title", pushObject.getPushStyle().getContentTitle());
        map.put("subtitle", pushObject.getPushStyle().getContentText());
        map.put("body", pushObject.getPushStyle().getContentText());
        map.put("pushType", pushObject.getPushType());
        map.put("pushId", pushObject.getPushId());
        map.put("pushInstanceId", pushObject.getPushInstanceId());
        map.put("sendDate", String.valueOf(pushObject.getSendDate()));
        map.put("inboxStatus", pushObject.getInboxStatus());
        if (pushObject.getDeepLink() != null) {
            map.put("deepLink", String.valueOf(pushObject.getDeepLink()));
        }
        if (pushObject.getExternalId() != null) {
            map.put("externalId", pushObject.getExternalId());
        }
        if (pushObject.getCategories() != null && !pushObject.getCategories().isEmpty()) {
            map.put("categories", pushObject.getCategories());
        }
        return map;
    }
}
