/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */

#import "FNetmeraPushObject.h"

@implementation FNetmeraPushObject


+(NSArray<NSDictionary*>*) mapPushObjects: (NSMutableArray<NetmeraPushObject *>*) pushObjects {
    NSMutableArray<NSDictionary*> *pushObjectList = [[NSMutableArray alloc]init];
    for (int i = 0; i < [pushObjects count]; i++) {
        [pushObjectList addObject: [self getPushObjectMap: pushObjects[i]]];
    }
    return pushObjectList;
}

+(NSDictionary*) getPushObjectMap:(NetmeraPushObject*) pushObject {
    NSMutableDictionary *data = [NSMutableDictionary dictionary];
    data[@"title"] = [[pushObject alert] title];
    data[@"subtitle"] = [[pushObject alert] subtitle];
    data[@"body"] = [[pushObject alert] body];
    data[@"pushType"] = [NSNumber numberWithInteger:[pushObject pushType]];
    data[@"inboxStatus"] = [NSNumber numberWithInteger:[pushObject inboxStatus]];
    data[@"pushId"] = [pushObject pushId];
    data[@"pushInstanceId"] = [pushObject pushInstanceId];
    data[@"deepLink"] = [[pushObject action] deeplinkURLString];
    data[@"externalId"] = [pushObject externalId];
    data[@"categories"] = [pushObject category];
    if(pushObject.sendDate){
        data[@"sendDate"] = [NSDateFormatter localizedStringFromDate:pushObject.sendDate
                                                           dateStyle:NSDateFormatterShortStyle
                                                           timeStyle:NSDateFormatterFullStyle];
    }
    return data;
}
@end
