import 'package:netmera_flutter_sdk/events/NetmeraEvent.dart';

///
/// Copyright (c) 2019 Inomera Research.
/// Author Burak Soykal
///
class NetmeraEventOrderCancel extends NetmeraEvent {
  @override
  getCode() => "n:co";

  double _subTotal;
  double _grandTotal;
  int _itemCount;
  String _paymentMethod;

  setSubTotal(double value) {
    _subTotal = value;
  }

  double getSubTotal() => _subTotal;

  setGrandTotal(double value) {
    _grandTotal = value;
  }

  double getGrandTotal() => _grandTotal;

  setItemCount(int value) {
    _itemCount = value;
  }

  int getItemCount() => _itemCount;

  setPaymentMethod(String value) {
    _paymentMethod = value;
  }

  String getPaymentMethod() => _paymentMethod;

  @override
  Map<String, Object> toJson() {
    Map<String, Object> map = super.toJson();
    map['er'] = _subTotal;
    map['es'] = _grandTotal;
    map['ec'] = _itemCount;
    map['em'] = _paymentMethod;
    return map;
  }
}
